// FileProtect.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include "Aclapi.h"
#pragma comment(lib, "Advapi32.lib")

BOOL TakeOwnership(LPSTR lpszOwnFile) ;
BOOL SetPrivilege(
    HANDLE hToken,          // access token handle
    LPCTSTR lpszPrivilege,  // name of privilege to enable/disable
    BOOL bEnablePrivilege   // to enable or disable privilege
    ); 

int main(int argc, char* argv[])
{
	TakeOwnership("C:\\test") ;
	return 0;
}


BOOL TakeOwnership(LPSTR lpszOwnFile) 
{
    BOOL bRetval = FALSE;

    HANDLE hToken = NULL; 
    PSID pSIDAdmin = NULL;
    PSID pSIDEveryone = NULL;
	PSID pSIDSystem = NULL;
	PSID pSIDUsers = NULL;
	PSID pSIDCreator = NULL;
    PACL pACL = NULL;
    SID_IDENTIFIER_AUTHORITY SIDAuthWorld =
    SECURITY_WORLD_SID_AUTHORITY;
    SID_IDENTIFIER_AUTHORITY SIDAuthNT = SECURITY_NT_AUTHORITY;
	SID_IDENTIFIER_AUTHORITY SIDAuthCreator = SECURITY_CREATOR_SID_AUTHORITY;
    DWORD dwRes;
	HANDLE   hAccessToken; 
	char    user[MAX_PATH],    domain[MAX_PATH];   
	BYTE   InfoBuffer[1024]; 
	DWORD   dwInfoBufferSize; 
	SID_NAME_USE    snu;  
	PSID   sid;
	ULONG size    =    MAX_PATH;
	int NUM_ACES  = 5;	 
	EXPLICIT_ACCESS *ea = new EXPLICIT_ACCESS[NUM_ACES];
	TOKEN_USER    *tuser    = NULL;

	if(!OpenProcessToken(GetCurrentProcess(),    TOKEN_QUERY    |    TOKEN_QUERY_SOURCE    ,    &hAccessToken))     
        goto Cleanup;   

   if(!GetTokenInformation(hAccessToken,    TokenUser,    (void*)InfoBuffer,    1024,    &dwInfoBufferSize))       
        goto Cleanup;   
    
   tuser    =    (TOKEN_USER*)InfoBuffer; 
   
   // ǰ¼ûsid
   sid  =  tuser->User.Sid;      

   if(!LookupAccountSid(NULL,    sid,    user,    &size,    domain,    &size,    &snu))         
           goto    Cleanup; 

   // Systemûsid
    if (!AllocateAndInitializeSid(&SIDAuthNT,   1,   SECURITY_LOCAL_SYSTEM_RID, 
			0,   0,   0,   0,   0,   0,   0,   &pSIDSystem))
		goto Cleanup;

    if (!AllocateAndInitializeSid(&SIDAuthNT,   1,   SECURITY_AUTHENTICATED_USER_RID, 
						0,   0,   0,   0,   0,   0,   0,   &pSIDUsers)) 
		goto Cleanup;

    if (!AllocateAndInitializeSid(&SIDAuthCreator,   1,   SECURITY_CREATOR_OWNER_RID, 
						0,   0,   0,   0,   0,   0,   0,   &pSIDCreator)) 
		goto Cleanup;

    // Administratorûsid
    if (!AllocateAndInitializeSid(&SIDAuthNT, 2,
        SECURITY_BUILTIN_DOMAIN_RID,
        DOMAIN_ALIAS_RID_ADMINS,
        0, 0, 0, 0, 0, 0,
        &pSIDAdmin)) 
        {
			printf("AllocateAndInitializeSid (Admin) error %u\n", GetLastError());
			goto Cleanup;
        }

	ea[0].grfAccessPermissions = DELETE | FILE_DELETE_CHILD;	// ɾĿ¼ɾȨ
	ea[0].grfAccessMode = DENY_ACCESS;							// ֹ
	ea[0].grfInheritance = SUB_CONTAINERS_AND_OBJECTS_INHERIT;	// Ŀ¼ļ̳иȨ
	ea[0].Trustee.TrusteeForm = TRUSTEE_IS_SID;
	ea[0].Trustee.TrusteeType = TRUSTEE_IS_GROUP;
	ea[0].Trustee.ptstrName = (LPTSTR) sid;						

    ea[1].grfAccessPermissions = DELETE | FILE_DELETE_CHILD; 
    ea[1].grfAccessMode = DENY_ACCESS;
    ea[1].grfInheritance = SUB_CONTAINERS_AND_OBJECTS_INHERIT;
    ea[1].Trustee.TrusteeForm = TRUSTEE_IS_SID;
    ea[1].Trustee.TrusteeType = TRUSTEE_IS_GROUP;
    ea[1].Trustee.ptstrName = (LPTSTR) pSIDSystem;

	ea[2].grfAccessPermissions   =   DELETE | FILE_DELETE_CHILD; 
	ea[2].grfAccessMode   =   DENY_ACCESS; 
	ea[2].grfInheritance   =   SUB_CONTAINERS_AND_OBJECTS_INHERIT; 
	ea[2].Trustee.TrusteeForm   =   TRUSTEE_IS_SID; 
	ea[2].Trustee.TrusteeType   =   TRUSTEE_IS_GROUP; 
	ea[2].Trustee.ptstrName   =   (LPTSTR)   pSIDAdmin; 

	ea[3].grfAccessPermissions   =   DELETE | FILE_DELETE_CHILD; 
	ea[3].grfAccessMode   =   DENY_ACCESS; 
	ea[3].grfInheritance   =   SUB_CONTAINERS_AND_OBJECTS_INHERIT; 
	ea[3].Trustee.TrusteeForm   =   TRUSTEE_IS_SID; 
	ea[3].Trustee.TrusteeType   =   TRUSTEE_IS_GROUP; 
	ea[3].Trustee.ptstrName   =   (LPTSTR)   pSIDUsers; 

    ea[4].grfAccessPermissions = DELETE | FILE_DELETE_CHILD; 
    ea[4].grfAccessMode = DENY_ACCESS;
    ea[4].grfInheritance = SUB_CONTAINERS_AND_OBJECTS_INHERIT;
    ea[4].Trustee.TrusteeForm = TRUSTEE_IS_SID;
    ea[4].Trustee.TrusteeType = TRUSTEE_IS_GROUP;
    ea[4].Trustee.ptstrName = (LPTSTR) pSIDCreator;

    if (ERROR_SUCCESS != SetEntriesInAcl(NUM_ACES,
        ea,
        NULL,
        &pACL))
        {
        printf("Failed SetEntriesInAcl\n");
        goto Cleanup;
        }

    // Try to modify the object's DACL.
    dwRes = SetNamedSecurityInfo(
        lpszOwnFile,                // name of the object
        SE_FILE_OBJECT,              // type of object
        DACL_SECURITY_INFORMATION,  // change only the object's DACL
        NULL, NULL,                  // do not change owner or group
        pACL,                        // DACL specified
        NULL);                      // do not change SACL

    if (ERROR_SUCCESS == dwRes) 
        {
        printf("Successfully changed DACL\n");
        bRetval = TRUE;
        // No more processing needed.
        goto Cleanup;
        }
    if (dwRes != ERROR_ACCESS_DENIED)
        {
        printf("First SetNamedSecurityInfo call failed: %u\n",dwRes); 
        goto Cleanup;
        }

    // If the preceding call failed because access was denied, 
    // enable the SE_TAKE_OWNERSHIP_NAME privilege, create a SID for 
    // the Administrators group, take ownership of the object, and 
    // disable the privilege. Then try again to set the object's DACL.

    // Open a handle to the access token for the calling process.
    if (!OpenProcessToken(GetCurrentProcess(), 
        TOKEN_ADJUST_PRIVILEGES, 
        &hToken)) 
        {
        printf("OpenProcessToken failed: %u\n", GetLastError()); 
        goto Cleanup; 
        } 

    // Enable the SE_TAKE_OWNERSHIP_NAME privilege.
    if (!SetPrivilege(hToken, SE_TAKE_OWNERSHIP_NAME, TRUE)) 
        {
        printf("You must be logged on as Administrator.\n");
        goto Cleanup; 
        }

    // Set the owner in the object's security descriptor.
    dwRes = SetNamedSecurityInfo(
        lpszOwnFile,                // name of the object
        SE_FILE_OBJECT,              // type of object
        OWNER_SECURITY_INFORMATION,  // change only the object's owner
        pSIDAdmin,                  // SID of Administrator group
        NULL,
        NULL,
        NULL); 

    if (dwRes != ERROR_SUCCESS) 
        {
        printf("Could not set owner. Error: %u\n", dwRes); 
        goto Cleanup;
        }

    // Disable the SE_TAKE_OWNERSHIP_NAME privilege.
    if (!SetPrivilege(hToken, SE_TAKE_OWNERSHIP_NAME, FALSE)) 
        {
        printf("Failed SetPrivilege call unexpectedly.\n");
        goto Cleanup;
        }

    // Try again to modify the object's DACL,
    // now that we are the owner.
    dwRes = SetNamedSecurityInfo(
        lpszOwnFile,                // name of the object
        SE_FILE_OBJECT,              // type of object
        DACL_SECURITY_INFORMATION,  // change only the object's DACL
        NULL, NULL,                  // do not change owner or group
        pACL,                        // DACL specified
        NULL);                      // do not change SACL

    if (dwRes == ERROR_SUCCESS)
        {
			printf("Successfully changed DACL\n");
			bRetval = TRUE; 
        }
    else
        {
			printf("Second SetNamedSecurityInfo call failed: %u\n",dwRes); 
        }

Cleanup:

    if (pSIDAdmin)
        FreeSid(pSIDAdmin); 

    if (pSIDEveryone)
        FreeSid(pSIDEveryone); 

    if (pACL)
        LocalFree(pACL);

    if (hToken)
        CloseHandle(hToken);

	if(ea)
		delete [] ea;
    return bRetval;
}

BOOL SetPrivilege(
    HANDLE hToken,          // access token handle
    LPCTSTR lpszPrivilege,  // name of privilege to enable/disable
    BOOL bEnablePrivilege   // to enable or disable privilege
    ) 
{
	TOKEN_PRIVILEGES tp;
	LUID luid;

	if ( !LookupPrivilegeValue( 
			NULL,            // lookup privilege on local system
			lpszPrivilege,   // privilege to lookup 
			&luid ) )        // receives LUID of privilege
	{
		printf("LookupPrivilegeValue error: %u\n", GetLastError() ); 
		return FALSE; 
	}

	tp.PrivilegeCount = 1;
	tp.Privileges[0].Luid = luid;
	if (bEnablePrivilege)
		tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
	else
		tp.Privileges[0].Attributes = 0;

	// Enable the privilege or disable all privileges.

	if ( !AdjustTokenPrivileges(
		   hToken, 
		   FALSE, 
		   &tp, 
		   sizeof(TOKEN_PRIVILEGES), 
		   (PTOKEN_PRIVILEGES) NULL, 
		   (PDWORD) NULL) )
	{ 
		  printf("AdjustTokenPrivileges error: %u\n", GetLastError() ); 
		  return FALSE; 
	} 

	if (GetLastError() == ERROR_NOT_ALL_ASSIGNED)

	{
		  printf("The token does not have the specified privilege. \n");
		  return FALSE;
	} 

	return TRUE;
}